#ifndef FD_Parameters_h_
#define FD_Parameters_h_
/* Header file generated with fdesign. */


#include "defs.h"
#include <forms.h>
#include "wavesim.def"
//#include <pthread.h>
//#include "/usr/include/X11/Xthreads.h"

/**** Callback routines ****/

extern void CB_Param_Apply(FL_OBJECT *, long);
extern void CB_Param_Close(FL_OBJECT *, long);
extern void CB_Param_Density(FL_OBJECT *, long);
extern void CB_Param_Tension(FL_OBJECT *, long);
extern void CB_Param_Step(FL_OBJECT *, long);
extern void CB_Param_GSTol(FL_OBJECT *, long);
extern void CB_Param_GSMaxIte(FL_OBJECT *, long);
extern void CB_Param_Deaden(FL_OBJECT *, long);

extern void CB_Menu_File(FL_OBJECT *, long);
extern void CB_Menu_View(FL_OBJECT *, long);
extern void CB_Menu_Help(FL_OBJECT *, long);
extern void CB_Fast_Bar(FL_OBJECT *, long);
extern void CB_Tool_Bot(FL_OBJECT *, long);

extern void CB_Geom_CuantizeX(FL_OBJECT *, long);
extern void CB_Geom_CuantizeY(FL_OBJECT *, long);
extern void CB_Geom_RealSizeX(FL_OBJECT *, long);
extern void CB_Geom_RealSizeY(FL_OBJECT *, long);
extern void CB_Geom_CuantSize(FL_OBJECT *, long);
extern void CB_Geom_Apply(FL_OBJECT *, long);
extern void CB_Geom_Close(FL_OBJECT *, long);

//extern void CB_Simu_Stop(FL_OBJECT *, long);
extern void CB_Simu_Play(FL_OBJECT *, long);
extern void CB_Simu_Step(FL_OBJECT *, long);
extern void CB_Simu_Level(FL_OBJECT *, long);
extern void CB_Simu_Restart(FL_OBJECT *, long);
extern void CB_Simu_Solution(FL_OBJECT *, long);
extern void CB_Simu_ColorScale(FL_OBJECT *, long);
extern void CB_Simu_Thickness(FL_OBJECT *, long);
extern void CB_Simu_WaveDlg(FL_OBJECT *, long);
extern void CB_Simu_RenderDlg(FL_OBJECT *, long);
extern void CB_Simu_Close(FL_OBJECT *, long);
extern void CB_Simu_ColMin(FL_OBJECT *, long);
extern void CB_Simu_ColZero(FL_OBJECT *, long);
extern void CB_Simu_ColMax(FL_OBJECT *, long);
extern void CB_Simu_Zoom(FL_OBJECT *, long);
extern void CB_Simu_Skip(FL_OBJECT *, long);
extern void CB_Simu_Timeout(int, void *);

extern void CB_Help_Close(FL_OBJECT *, long);

extern void CB_About_Close(FL_OBJECT *, long);

extern void CB_Render_RXRY(FL_OBJECT *, long);
extern void CB_Render_RotZ(FL_OBJECT *, long);
extern void CB_Render_Close(FL_OBJECT *, long);
extern void CB_Render_Mode(FL_OBJECT *, long);
extern void CB_Render_Zoom(FL_OBJECT *, long);
extern void CB_Render_HScale(FL_OBJECT *, long);

extern void CB_Wave_Close(FL_OBJECT *, long);
extern void CB_Wave_Freq(FL_OBJECT *, long);
extern void CB_Wave_Restart(FL_OBJECT *, long);
extern void CB_Wave_Play(FL_OBJECT *, long);
extern void CB_Wave_Rec(FL_OBJECT *, long);
extern void CB_Wave_Zoom(FL_OBJECT *, long);


/**** Forms and Objects ****/

typedef struct {
	FL_FORM *Parameters;
	void *vdata;
	long ldata;
	FL_OBJECT *Close_Bot[3];
	FL_OBJECT *Scale[5];
	FL_OBJECT *Scroll[6];
} FD_Parameters;

extern FD_Parameters * create_form_Parameters(void);
typedef struct {
	FL_FORM *Main;
	void *vdata;
	long ldata;
	FL_OBJECT *Main_Logo;
	FL_OBJECT *Design_Board;
	FL_OBJECT *Tool_Bots;
	FL_OBJECT *Main_Menu[3];
	FL_OBJECT *Fast_Bar[3];
	FL_OBJECT *Tool_Bot[9];
        FL_OBJECT *Box_Pos;
} FD_Main;

extern FD_Main * create_form_Main(void);
typedef struct {
	FL_FORM *Geometry;
	void *vdata;
	long ldata;
	FL_OBJECT *Scroll[5];
	FL_OBJECT *Scale[3];
	FL_OBJECT *Close_Bot[3];
} FD_Geometry;

extern FD_Geometry * create_form_Geometry(void);
typedef struct {
	FL_FORM *Simulation;
	void *vdata;
	long ldata;
	FL_OBJECT *Scroll_Level;
	FL_OBJECT *Solution;
	FL_OBJECT *Shape;
	FL_OBJECT *Scroll_ColorScale;
	FL_OBJECT *Scroll_Thickness;
	FL_OBJECT *WaveDlg_Bot;
	FL_OBJECT *Simu_Board;
	FL_OBJECT *RenderDlg_Bot;
	FL_OBJECT *Close_Bot;
	FL_OBJECT *Control_Bot[3];
	FL_OBJECT *Solution_Bot[2];
	FL_OBJECT *R_Scroll[3];
	FL_OBJECT *G_Scroll[3];
	FL_OBJECT *B_Scroll[3];
	FL_OBJECT *Muestra_Col[3];
        FL_OBJECT *Scroll_Zoom;
        FL_OBJECT *Scroll_Skip;
        FL_OBJECT *Box_RealX;
        FL_OBJECT *Box_RealY;
        FL_OBJECT *Box_Time;
        FL_OBJECT *Box_PosX;
        FL_OBJECT *Box_PosY;
        FL_OBJECT *Box_Step;
        FL_OBJECT *Box_Value;
} FD_Simulation;

extern FD_Simulation * create_form_Simulation(void);
typedef struct {
	FL_FORM *Help;
	void *vdata;
	long ldata;
        
      	FL_OBJECT *Help_Browser;
      	FL_OBJECT *Close_Bot;
} FD_Help;

extern FD_Help * create_form_Help(void);
typedef struct {
	FL_FORM *About;
	void *vdata;
	long ldata;
	FL_OBJECT *Close_Bot;
} FD_About;

extern FD_About * create_form_About(void);
typedef struct {
	FL_FORM *Render;
	void *vdata;
	long ldata;
	FL_OBJECT *Render_Board;
	FL_OBJECT *RXRY_Posit;
	FL_OBJECT *RotZ_Scroll;
	FL_OBJECT *Close_Bot;
	FL_OBJECT *Render_Mode_Bots;
	FL_OBJECT *Zoom_Scroll;
	FL_OBJECT *Mode_Bot[4];
        FL_OBJECT *HScale_Scroll;
} FD_Render;

extern FD_Render * create_form_Render(void);
typedef struct {
	FL_FORM *Wave;
	void *vdata;
	long ldata;
	FL_OBJECT *Close_Bot;
	FL_OBJECT *Wave_Plot;
	FL_OBJECT *Freq_Scroll;
	FL_OBJECT *Restart_Bot;
	FL_OBJECT *Play_Bot;
	FL_OBJECT *Rec_Bot;
	FL_OBJECT *Zoom_Scroll;
} FD_Wave;

extern FD_Wave * create_form_Wave(void);


extern FD_Parameters *fd_Parameters;
extern FD_Main *fd_Main;
extern FD_Geometry *fd_Geometry;
extern FD_Simulation *fd_Simulation;
extern FD_Help *fd_Help;
extern FD_About *fd_About;
extern FD_Render *fd_Render;
extern FD_Wave *fd_Wave;



#endif /* FD_Parameters_h_ */
